rat(1)

NAME
rat - unicast and multicast audio conferencing tool

SYNOPSIS
rat [options] address/port

DESCRIPTION

RAT is a network audio conferencing and streaming application with support for multiple sampling rates, error concealment, and redundant audio encoding. Transmissions can be between two participants directly (unicast) or between a group of participants on a common multicast address.

To initiate a unicast conference the user specifies the address of the destination host name or IP address and a port number. To participate in a multicast conference a Class D group address should be specified together with a port number. The application uses the greatest even integer less than or equal to the port specified for data (RTP) and the port above for control messages (RTCP). The protocols RTP and RTCP used are specified in RFC 1889.

OPTIONS
The following options are supported:

-agc 1|0
    Enable automatic gain control (AGC).

-allowloopback
    Causes rtp packets to be loopbacked during multicast sessions.

-crypt key
    Enable encryption, with the specified key. Encryption is done using DES, and is believed compatible with encrypting versions of vat.

-C name
    Sets the RAT window title to name.

-E email
    Sets the email address transmitted to remote participants.

-f codec
    Specifies the primary encoding used when transmitting audio.

-L location
    Sets the location description transmitted to remote participants.

-N username
    Sets the username transmitted to remote participants.

-P phone
    Sets the phone number transmitted to remote participants.

-pt type/codec
    Specifies the payload type to be used for codec.

-r codec/offset
    Specifies the coding used for the redundant encoder and the offset of the redundant encoding relative to the primary in audio frames.

-repair method
    Specifies the use of receiver based repair technique based on method. This can currently be none or repeat.

-t ttl
    Specifies the TTL (time to live) value set in the packet headers. This limits the scope of the packets. The following values are generally considered appropriate:
      4 campus/organization
     16 country
     64 continent
    127 planet

-silence 1|0
    Turns silence suppression on or off.

-version
    Displays the version number.

USER INTERFACE

  Main Window

The main window of RAT is split into three sections. At the top of the window are the audio device port and volume selectors, and the mutes for incoming and outgoing audio. In the middle the list of participants shows local and remote conference members. Active speakers are highlighted. Clicking the left mouse button on the name of a remote participant will display a user information panel, giving various reception statistics for that user. Individuals can be selectively muted by clicking on them with the middle mouse button on three button systems, or moving the mouse to the individual and pressing the m. At the bottom of the window are buttons for the options panel, the about panel, and to quit.

Pressing the right mouse button anywhere within the RAT window will temporarily toggle the state of the audio input mute: this allows a "push-to-talk" mode of operation.

  Options

RAT supports a large number of options and pressing the "options" button will launch the optinos panel. The best approach to see what is available is to go and explore. The options panel has a category menu at the top and by clicking on it options in the different categories are presented.

Personal
    User details that are conveyed to other conference participants.

Transmission
    Allows the selection of codec used for transmission, the setting of the number, of units of audio per packet, and the selection of redundant audio data.

Reception
    Options that control how received audio is decoded.

Audio
    Options to select and configure the available audio device, and features that pertain to audio handling (i.e. silence suppression, agc, audio loopback, and echo suppression).

Codecs
    Displays details on available codecs and allows for them to be assigned to alternate RTP payload numbers. Map payload numbers at your own peril.

Security
    Allows DES encryption of audio for incoming and outgoing streams.

Interface
    Allows users to control balloon help, enable lip synchronization with suitably modified versions of VIC , and displaying of windows for reception quality and file playback and recording.

EXAMPLES
To start a unicast session between the current host and the host shrew.cs.ucl.ac.uk using port 12000 type:

        rat shrew.cs.ucl.ac.uk/12000

To join a multicast session on group address 224.5.6.7 and port 8110 type, using primary encoding of dvi and a secondary encoding of lpc:

        rat -f dvi/lpc 224.5.6.7/8110

AUTHORS
This version of RAT was written by Orion Hodson <O.Hodson@cs.ucl.ac.uk> and Colin Perkins <C.Perkins@cs.ucl.ac.uk> in the Networked Multimedia Group, University College London. Markus Iken contributed the 3d rendering code. Bob's Olson and Lindell contributed the ALSA audio interface.

The first version of RAT was developed by Vicky Hardman <V.Hardman@cs.ucl.ac.uk> and Isidor Kouvelas <I.Kouvelas@cs.ucl.ac.uk> at University College London. The DES encryption was written by Saleem Bhatti <S.Bhatti@cs.ucl.ac.uk> and integrated by Darren Harris.

RAT has been supported by the following projects: <IP>
MICE     Multimedia Conferencing in Europe (ESPRIT)

MERCI     Multimedia European Research Conferencing Integration

ReLaTe     Remote Language Teaching for Super Janet (BT/JISC)

RAT     Robust Audio Tool (EPSRC/BT)

This software has benefited from hardware donations by Sun Microsystems and Hewlett Packard, and software donations by Microsoft.

ACKNOWLEDGEMENTS

We thank Roy Bennett, Davide Cavagnino, Jon Crowcroft, Ross Finlayson, Atanu Ghosh, Terry Gibbons, Jeremy Hall, Mark Handley, Marcus Iken, Iain McKay, Roman Kurmanowyts, Robert Olson, Fulvio Risso, Roy Rodenstein, Lorenzo Vicisano, Anna Watson, Michael Wallbaum, Hui Zhao, and our collegues at UCL who have provided countless suggestions and extended good humour through the buggy pre-releases.

Modifications for HP-UX by Terje Vernly <terjeve@usit.uio.no> and Geir Harald Hansen <g.h.hansen@usit.uio.no>.

This software is derived, in part, from publically available source code with the following copyright:

Copyright (c) 1991-1993,1996 Regents of the University of California.

Copyright (c) 1992 Stichting Mathematisch Centrum, Amsterdam.

Copyright (c) 1991,1992 RSA Data Security, Inc.

Copyright (c) 1992 Jutta Degener and Carsten Bormann, Technische Universitaet Berlin.

Copyright (c) 1994 Henning Schulzrinne.

Copyright (c) 1994 Paul Stewart.

This product includes software developed by the Computer Systems Engineering Group and by the Network Research Group at Lawrence Berkeley Laboratory.

Encryption features of this software use the RSA Data Security, Inc. MD5 Message-Digest Algorithm.

FEEDBACK
Please send comments, bug-reports, patches, and suggestions to rat-trap@cs.ucl.ac.uk.

Please check http://www-mice.cs.ucl.ac.uk/multimedia/software for latest release information.